#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND TESTED IN A WINDOWS ENVIRONMENT ONLY AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Spin It
#      By:	sdmitch
#   Usage:	To rotate the View or objects for animation purposes.
#		 Note:	
#			
#    Date:	Dec 2011
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
    sub = UI.menu('Plugins').add_submenu('Spin It')
	sub.add_item("Spin View") { SDM_Spin.spin_view }
	sub.add_item("Spin Object") { SDM_Spin.spin_object }
	file_loaded(File.basename(__FILE__))
end
#
module SDM_Spin

	def self.spin_view
		@record = "No" if !@record
		@angle = 1.0 if !@angle
		@delay = 0.1 if !@delay
		@turns = 1 if !@turns
		inp = inputbox(["Record:"," Angle:"," Delay:"," Turns:"],[@record,@angle,@delay,@turns],["Yes|No"],"Spin View")
		if inp
			@record=inp[0]; @angle=inp[1].to_f; @delay=inp[2].to_f; @turns=inp[3].to_f
			mod = Sketchup.active_model
			vue = mod.active_view
			tar = vue.guess_target
			cam = vue.camera
			eye = cam.eye
			pages = mod.pages
			tr=Geom::Transformation.rotation(tar,Z_AXIS,@angle.degrees)
			if @record == "Yes" && pages.count > 0
				if UI.messagebox("Erase existing Scenes?",MB_YESNO)==6
					while pages.count > 0
						pages.each{|page| pages.erase page}
					end
				end
			end
			nxt = pages.count
			(nxt += 1; pages.add "Scene #{nxt}") if @record == "Yes"
			for i in 1..(360*@turns/@angle).to_i
				eye.transform! tr
				cam.set eye,tar,Z_AXIS
				vue.refresh
				(nxt += 1; pages.add "Scene #{nxt}") if @record == "Yes"
				sleep(@delay)#control speed of rotation
			end
		end
	end
	
	def self.spin_object
		mod = Sketchup.active_model
		ent = mod.entities
		sel = mod.selection
		unless sel.empty?
			pages = mod.pages
			@angle = 1.0 if !@angle
			@delay = 0.1 if !@delay
			@turns = 1 if !@turns
			inp = inputbox([" Angle:"," Delay:"," Turns:"],[@angle,@delay,@turns],"Spin Selected Objects")
			if inp
				@angle=inp[0].to_f; @delay=inp[1].to_f; @turns=inp[2].to_f
				corg=[]; sel.each{|e| corg<<e if e.class==Sketchup::Group || \
				(e.class==Sketchup::ComponentInstance and not e.definition.behavior.always_face_camera? and not e.definition.behavior.shadows_face_sun?)}
				if corg[0]
					sel.clear
					for i in 1..(360*@turns/@angle).to_i
						corg.each{|e|
						tr=Geom::Transformation.rotation(e.bounds.center,Z_AXIS,@angle.degrees)
						e.transform! tr}
						Sketchup.active_model.active_view.refresh
						sleep(@delay)
					end
				else
					UI.messagebox "No components or groups in the selection"
				end
			end
		else
			UI.messagebox "Nothing selected"
		end
	end
	
end
